// ProgressDlg.cpp : implementation file
//

#include "stdafx.h"
#include "rootfly.h"
#include "ProgressDlg.h"
#include <sstream>
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// ProgressDlg dialog


ProgressDlg::ProgressDlg(ProgressData *data, CWnd* pParent /*=NULL*/)
	: CDialog(ProgressDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(ProgressDlg)
	//}}AFX_DATA_INIT

  m_progress_data = data;
}


void ProgressDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(ProgressDlg)
	DDX_Control(pDX, IDC_TOTAL_ANNOTATED, m_total_annotated);
	DDX_Control(pDX, IDC_TOTAL_IMAGES, m_total_images);
	DDX_Control(pDX, IDC_PROGRESS_STATISTIC, m_statistic_text);
	DDX_Control(pDX, IDC_PROGRESS_SESSION, m_session_selection);
	DDX_Control(pDX, IDC_PROGRESS_TUBE, m_tube_selection);
	DDX_Control(pDX, IDC_PROGRESS_WINDOW, m_window_selection);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(ProgressDlg, CDialog)
	//{{AFX_MSG_MAP(ProgressDlg)
	ON_CBN_SELCHANGE(IDC_PROGRESS_TUBE, OnSelchangeProgress)
	ON_CBN_SELCHANGE(IDC_PROGRESS_WINDOW, OnSelchangeProgress)
	ON_CBN_SELCHANGE(IDC_PROGRESS_SESSION, OnSelchangeProgress)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// ProgressDlg message handlers

BOOL ProgressDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

  InitTotals();
  InitSelection();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void ProgressDlg::InitTotals()
{
  CString text;

  text.Format("Total Images: %d", m_progress_data->GetImageCount());
  m_total_images.SetWindowText(text);
  
  text.Format("Total Annotated: %d", m_progress_data->GetAnnotatedCount());
  m_total_annotated.SetWindowText(text);
}

void ProgressDlg::InitSelection()
{
  const bool *i, *first, *end;
  CString item;

  i = first = m_progress_data->GetTubeList()->begin();
  end = m_progress_data->GetTubeList()->end();
  while (i < end)
  {
    if (*i)
    {
      item.Format("Tube %2d", i - first);
      m_tube_selection.AddString(item);
    }
    i++;
  }
  m_tube_selection.AddString("All Tubes");

  i = first = m_progress_data->GetWindowList()->begin();
  end = m_progress_data->GetWindowList()->end();
  while (i < end)
  {
    if (*i)
    {
      item.Format("Window %2d", i - first);
      m_window_selection.AddString(item);
    }
    i++;
  }
  m_window_selection.AddString("All Windows");

  i = first = m_progress_data->GetSessionList()->begin();
  end = m_progress_data->GetSessionList()->end();
  while (i < end)
  {
    if (*i)
    {
      item.Format("Session %2d", i - first);
      m_session_selection.AddString(item);
    }
    i++;
  }

  m_session_selection.AddString("All Sessions");
}

void ProgressDlg::OnSelchangeProgress() 
{
	CString text;

	m_window_selection.GetLBText(m_window_selection.GetCurSel(),text);
	bool all_windows = text=="All Windows";
	m_tube_selection.GetLBText(m_tube_selection.GetCurSel(),text);
	bool all_tubes = text=="All Tubes";
	m_session_selection.GetLBText(m_session_selection.GetCurSel(),text);
	bool all_sessions=text=="All Sessions";

/*
	if(!all_tubes && !all_sessions && !all_windows){
		if(m_progress_data.GetExists(
		m_statistic_text=
	}

  stripString(text);
*/
}


int ProgressDlg::stripString(CString strip_string)
{
	CString temp;
	for(int i=strip_string.ReverseFind(' ');i<strip_string.GetLength();i++){
		temp+=strip_string.GetAt(i);
	}
	int n;
	std::string toIntString(temp);
	std::stringstream ss(toIntString);
    ss >> n;

	//if(n==4)
		//MessageBox("corrent int","strip string");
    return n;
}

int ProgressDlg::stringToInt(const CString &str)
{
	std::string temp(str);
	std::stringstream ss(temp);
    int n;
    ss >> n;
	return n;
}
